<?php
/**
 *  JAX.php
 *
 *  JSONAArrayAXML𑊌݂ɕϊ
 *  XML̑"@"AText Node"#"ijƂKEY̒lɂȂiIvVj
 *  XMLJSON܂ArrayɕϊꍇArootvf͎̂Ă
 *
 *  @version   0.1.1
 *  @see       http://0-oo.net/sbox/php-tool-box/jax
 *  @copyright 2011-2013 dgbadmin@gmail.com
 *  @license   http://0-oo.net/pryn/MIT_license.txt (The MIT license)
 *
 *  See also
 *  @see http://www.php.net/manual/ja/book.simplexml.php
 *  @see http://www.php.net/manual/ja/ref.json.php
 */
class JAX {
	private $_options;
 
	/**
	 *	RXgN^
	 *	@param	array	$options	(Optional)
	 */
	public function __construct(array $options = array()) {
	 	// $opionts['xml_text_#']: XMLText NodeKEY"#"ɂ邩
		$this->_options = array_merge(array('xml_text_#' => false), $options);
	}
	/**
	 *	XMLAzzɂ
	 *	@param	string	$xmlStr
	 *	@param	string	$nameSpace	(Optional) XMLNameSpace
	 *	@return	array
	 */
	public function xml2array($xmlStr, $nameSpace = '') {
		return $this->_eachXml($this->_str2xml($xmlStr, $nameSpace));
	}
	/**
	 *	XMLJSONɂ
	 *	@param	string	$xmlStr
	 *	@param	string	$nameSpace	(Optional) XMLNameSpace
	 *	@return	string
	 */
	public function xml2json($xmlStr, $nameSpace = '') {
		return $this->array2json($this->xml2array($xmlStr, $nameSpace));
	}
	/**
	 *	ziAzzjXMLɂ
	 *	@param	string	$rootName	rootvf
	 *	@param	array	$arr
	 *	@return	string
	 */
	public function array2xml($rootName, array $arr) {
		return $this->_str2xml($this->_toXmlString($rootName, $arr))->asXML();
	}
	/**
	 *  ziAzzjJSONɂ
	 *  @param	array	$arr
	 *  @return	string
	 */
	public function array2json(array $arr) {
		$json = json_encode(
			$arr,
			JSON_HEX_TAG | JSON_HEX_AMP | JSON_HEX_APOS | JSON_HEX_QUOT
		);
 
		$this->_validateJson();
		return $json;
	}
	/**
	 *  JSONXMLɂ
	 *	@param	string	$rootName	rootvf
	 *  @param	string	$jsonStr
	 *  @return	string
	 *  @throws	Exception	JSONfR[hG[
	 */
	public function json2xml($rootName, $jsonStr) {
		return $this->array2xml($rootName, $this->json2array($jsonStr));
	}
	/**
	 *  JSONAzzɂ
	 *  @param	string	$jsonStr
	 *  @return	array
	 *  @throws	Exception	JSONfR[hG[
	 */
	public function json2array($jsonStr) {
		$arr = json_decode($jsonStr, true);
		$this->_validateJson();
		return $arr;
	}
	/**
	 *	񂩂SimpleXMLElementIuWFNg𐶐
	 *	@param	string	$xmlStr
	 *	@param	string	$nameSpace	(Optional) XMLNameSpace
	 *	@return	SimpleXMLElement
	 */
	private function _str2xml($xmlStr, $nameSpace = '') {
		return new SimpleXMLElement(
			$xmlStr,
			LIBXML_COMPACT | LIBXML_NOERROR,
			false,
			$nameSpace
		);
	}
	/**
	 *	ċAIXMLzɂ
	 *	@param	SimpleXMLElement	$xml
	 *	@return	array
	 */
	private function _eachXml(SimpleXMLElement $xml) {
		$arr = array();
		$attrs = (array)$xml->attributes();
 
		if ($attrs) {
			$arr['@'] = $attrs['@attributes'];
		}
 
		if (!$xml->count()) {	// qvfꍇ
			$text = (string)$xml;
 
			if ($this->_options['xml_text_#'] || $arr['@']) {
				$arr['#'] = $text;
				return $arr;
			} else {
				return $text;
			}
		}
 
		foreach ($xml->children() as $child) {
			$name = $child->getName();
			$grandchild = $this->_eachXml($child);
 
			if ($arr[$name]) {	// vfłꍇ
				if (is_array($arr[$name]) && $arr[$name][0]) {	// z񉻍ς݂̏ꍇ
					$arr[$name][] = $grandchild;
				} else {
					$arr[$name] = array($arr[$name], $grandchild);	// z
				}
			} else {
				$arr[$name] = $grandchild;
			}
		}
 
		return $arr;
	}
	/**
	 *  ċAIɘAzzXMLɂ
	 *  @param	string	$name
	 *  @param	mixed	$data
	 *  @return	string
	 */
	private function _toXmlString($name, $data) {
		$s = '';
		$attr = '';
 
		if (is_array($data)) {
			foreach ($data as $k => $v) {
				if ($k === '@') {
					foreach ($v as $attrName => $attrValue) {
						$attr .= " $attrName=" . '"' . $this->_xmlEscape($attrValue) . '"';
					}
				} else if ($k === '#') {
					$s = $this->_xmlEscape($v);
				} else if (is_numeric($k)) {
					$s .= $this->_toXmlString($name, $v);
				} else {
					$s .= $this->_toXmlString($k, $v);
				}
			}
		} else {
			$s = $this->_xmlEscape($data);
		}
 
		return "<$name$attr>$s</$name>";
	}
	/**
	 *  XML̕GXP[v
	 *  @param	string	$value
	 *  @return	string
	 */
	private function _xmlEscape($value) {
		return htmlSpecialChars($value, ENT_QUOTES, 'UTF-8');
	}
	/**
	 *  JSONϊG[Ăꍇ͗O𓊂
	 *  @throws	Exception
	 */
	private function _validateJson() {
		$error = json_last_error();
 
		if ($error === JSON_ERROR_NONE) {
			return;
		}
 
		$errors = array(
			'JSON_ERROR_DEPTH',
			'JSON_ERROR_STATE_MISMATCH',
			'JSON_ERROR_CTRL_CHAR',
			'JSON_ERROR_SYNTAX',
			'JSON_ERROR_UTF8',
		);
 
		foreach ($errors as $str) {
			if ($error === constant($str)) {
				throw new Exception($str);
			}
		}
 
		throw new Exception("Unknown JSON error ($error)");
	}
}
?>